
package de.ivu.elect.business.wahlbeteiligung.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebiet;

// abgeleitete Klasse mit "@javax.ejb.Stateless" annotieren!
public abstract class AbstractWahlbeteiligungVerlaufGebietEdit {

  @Inject
  protected WahlbeteiligungVerlaufGebietDAO dao;

  @Inject
  protected WahlbeteiligungVerlaufGebietExtendedDAO extendedDao;

  public void delete(WahlbeteiligungVerlaufGebiet entity) {
    dao.remove(getAttachedEntity(entity));
  }

  public void save(WahlbeteiligungVerlaufGebiet entity) {
    validate(entity);

    flushToSave();
  }

  protected void validate(WahlbeteiligungVerlaufGebiet entity) {
    // Do nothing by default.
  }

  protected void flushToSave() {
    if(usesMixedTransactionalContexts()) {
        extendedDao.flushNewTransaction();
    } else {
        extendedDao.flush();
    }
  }

  // ELECT-945
  protected boolean usesMixedTransactionalContexts() {
    return false;
  }

  protected WahlbeteiligungVerlaufGebiet getAttachedEntity(WahlbeteiligungVerlaufGebiet entity) {
    return dao.findByPrimaryKey(entity.getPk());
  }

  // Cf. ELECT-3187 (Änderungen an Entität werden nicht gespeichert)
  protected WahlbeteiligungVerlaufGebiet getAttachedAndRefreshedEntity(WahlbeteiligungVerlaufGebiet entity) {
    return dao.refresh(entity);
  }
}
